Subject: bug#24510: 25.1; Info: searching for ` does not find what looks like `

From: Drew Adams <[email-masked]>
Date: Thu, 22 Sep 2016 12:58:49 -0700 (PDT)

> > emacs -Q
> > C-h r g Dired
> > C-s `list
> > finds nothing, missing the occurrence of ‘list-directory’ that
> > is in the same node.
> >
> > What looks exactly (AFAICT) like the backquote you typed at the
> > prompt is NOT the same as the character that precedes
> > "list-directory" in the buffer.
> 
> It doesn't look exactly like it here.  In fact, it looks quite
> different.  Although it could be that on your system Emacs uses
> different fonts than those on mine.

See attached screenshot.  No, they are not EXACTLY the same.  But
a user who is used to searching for ` (from the backquote key) in
such a context can easily think that it IS the same character.

S?he can easily either think (1) that the text s?he (thought s?he
was) searching for is not present (e.g., if s?he does not see it)
or (2) that Isearch is not working properly for some reason.

> But if 2 characters from 2 different fonts look the same on your
> system, I think you should customize the Info faces to countermand
> that.  I don't see any other solution.

Again, this is emacs -Q.  The chars look quite different with my
own setup - this is not a problem for me, personally.

This is a problem for Emacs.  This is using the default font
(on my platform, which is nevertheless a common one: MS Windows).

This is the font used by emacs -Q:
-outline-Courier New-normal-normal-normal-mono-17-*-*-*-c-*-iso8859-1

That's a very common MS Windows fixed-width font.  And it has,
in the past, been a reasonable default choice.  Doesn't seem
so reasonable anymore.

> > And it is not matched to that character by Isearch.
> 
> It might, if you turn on character-folding in Isearch.
> Unfortunately, that is off by default.

I did mention that this is what a user sees by DEFAULT, no?

And I did propose that one fix could be for search to find
this character - by default - when you hit the backquote key:

  The default font for Emacs should be changed.  Or else search
  should, by default, find the character used when you type a
  backquote char.  Or else the character used, by default,
  should be backquote, not LEFT SINGLE QUOTATION MARK.  Or some
  other reasonable solution should be found, to remedy this
  annoyance.

> > Emacs provides a default font where these two characters are
> > visually indistinguishable.
> 
> Emacs doesn't provide any fonts.  Your system does.  On my system,
> these two characters look different, even with my old weary eyes.

They look slightly different, yes.  Barely noticeable when you
see them side by side (see screenshot).

But otherwise not noticeable enough that someone used to Emacs
< 25.1 would expect that the ` s?he types (as s?he always has,
for this) does not result in the same character s?he sees as a
name left delimiter.

If you do not want to accept that this is an obvious gotcha, fine.
Perhaps you will hear from other users about this; perhaps not.

> > Hard to believe this annoyance has gotten as far as it has (release
> > 25.1).  Did no one try searching our manuals using Emacs -Q?
> 
> We did.  It works for me.

If it works for you then that's all we can hope for, I guess.